const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class TenantsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const tenants = await db.tenants.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        subdomain: data.subdomain || null,
        status: data.status || null,
        trial_ends_at: data.trial_ends_at || null,
        billing_email: data.billing_email || null,
        billing_phone: data.billing_phone || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await tenants.setPlan(data.plan || null, {
      transaction,
    });

    await tenants.setAgences(data.agences || null, {
      transaction,
    });

    return tenants;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const tenantsData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      subdomain: item.subdomain || null,
      status: item.status || null,
      trial_ends_at: item.trial_ends_at || null,
      billing_email: item.billing_email || null,
      billing_phone: item.billing_phone || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const tenants = await db.tenants.bulkCreate(tenantsData, { transaction });

    // For each item created, replace relation files

    return tenants;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const tenants = await db.tenants.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    if (data.subdomain !== undefined) updatePayload.subdomain = data.subdomain;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.trial_ends_at !== undefined)
      updatePayload.trial_ends_at = data.trial_ends_at;

    if (data.billing_email !== undefined)
      updatePayload.billing_email = data.billing_email;

    if (data.billing_phone !== undefined)
      updatePayload.billing_phone = data.billing_phone;

    updatePayload.updatedById = currentUser.id;

    await tenants.update(updatePayload, { transaction });

    if (data.plan !== undefined) {
      await tenants.setPlan(
        data.plan,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await tenants.setAgences(
        data.agences,

        { transaction },
      );
    }

    return tenants;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const tenants = await db.tenants.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of tenants) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of tenants) {
        await record.destroy({ transaction });
      }
    });

    return tenants;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const tenants = await db.tenants.findByPk(id, options);

    await tenants.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await tenants.destroy({
      transaction,
    });

    return tenants;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const tenants = await db.tenants.findOne({ where }, { transaction });

    if (!tenants) {
      return tenants;
    }

    const output = tenants.get({ plain: true });

    output.claims_tenant = await tenants.getClaims_tenant({
      transaction,
    });

    output.clients_tenant = await tenants.getClients_tenant({
      transaction,
    });

    output.company_profiles_tenant = await tenants.getCompany_profiles_tenant({
      transaction,
    });

    output.drivers_tenant = await tenants.getDrivers_tenant({
      transaction,
    });

    output.expenses_tenant = await tenants.getExpenses_tenant({
      transaction,
    });

    output.guarantees_tenant = await tenants.getGuarantees_tenant({
      transaction,
    });

    output.infractions_tenant = await tenants.getInfractions_tenant({
      transaction,
    });

    output.invoices_saas_tenant = await tenants.getInvoices_saas_tenant({
      transaction,
    });

    output.maintenance_tenant = await tenants.getMaintenance_tenant({
      transaction,
    });

    output.payments_tenant = await tenants.getPayments_tenant({
      transaction,
    });

    output.reservations_tenant = await tenants.getReservations_tenant({
      transaction,
    });

    output.subscriptions_tenant = await tenants.getSubscriptions_tenant({
      transaction,
    });

    output.vehicle_conditions_tenant =
      await tenants.getVehicle_conditions_tenant({
        transaction,
      });

    output.vehicles_tenant = await tenants.getVehicles_tenant({
      transaction,
    });

    output.plan = await tenants.getPlan({
      transaction,
    });

    output.agences = await tenants.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.plans,
        as: 'plan',

        where: filter.plan
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.plan
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.plan
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('tenants', 'name', filter.name),
        };
      }

      if (filter.subdomain) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('tenants', 'subdomain', filter.subdomain),
        };
      }

      if (filter.billing_email) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'tenants',
            'billing_email',
            filter.billing_email,
          ),
        };
      }

      if (filter.billing_phone) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'tenants',
            'billing_phone',
            filter.billing_phone,
          ),
        };
      }

      if (filter.trial_ends_atRange) {
        const [start, end] = filter.trial_ends_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            trial_ends_at: {
              ...where.trial_ends_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            trial_ends_at: {
              ...where.trial_ends_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.tenants.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('tenants', 'name', query),
        ],
      };
    }

    const records = await db.tenants.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
